% 2021-02-14 11:09:28
\section{Get Started}
I'm going to describe how work \emph{MicroPython - Neural Network} with a very small an simple example.
In this classifier we are using a \emph{Sigmoid} activation function as $\sigma(x)$ and his derivative as $\sigma'(x)$.
Here is what we want to predict, with $i_n$ as inputs and $s_n$ as the expected classification.

\begin{table}[H]
\centering
\begin{tabular}{ccc||cc}
$i_{1}$ & $i_{2}$ & $i_{3}$ & $s_{1}$ & $s_{2}$\\
\hline
0 & 0 & 0 & 1 & 0 \\
0 & 0 & 1 & 0 & 1 \\
0 & 1 & 1 & 0 & 1 \\
0 & 1 & 0 & 1 & 0 \\
1 & 1 & 0 & 0 & 1 \\
1 & 1 & 1 & 1 & 0 \\
1 & 0 & 1 & 0 & 1 \\
1 & 0 & 0 & 1 & 0 \\
\end{tabular}
\caption{Training set}
\end{table}

We use a neural network (3, 4, 2).
With 3 values in the input layer, 4 values in the hidden layer and 2 values in the output layer.

\begin{figure}[H]
\centering
\includegraphics[width=0.3\linewidth]{gv/NeuralNetworkDFF342Detail.pdf}
\caption{Neural network (3, 4, 2) detail}
\end{figure}

Input layer is represented by the matrix $I$ and the output by the matrix $O$.
Hidden layer is matrix $H$.
Weights between matrix $I$ and $H$ is matrix $W_{ih}$.
Weights between matrix $H$ and $O$ is matrix $W_{ho}$.

\begin{equation}
\begin{split}
\sigma (x) = \frac{1}{1 + e^{-x} } \\
\sigma'(x) = \sigma (x) \cdot (1 - \sigma (x)) \\
\sigma'(x_\sigma) = x_\sigma \cdot (1 - x_\sigma) \\
%\sigma'(x) = x \cdot (1 - x)
\end{split}
\end{equation}

\begin{equation}
I = \begin{pmatrix}
i_{1} & i_{2} & i_{3}
\end{pmatrix}
\end{equation}

\begin{equation}
W_{ih} = \begin{pmatrix}
w^{ih}_{1,1} & w^{ih}_{1,2} & w^{ih}_{1,3} & w^{ih}_{1,4} \\
w^{ih}_{2,1} & w^{ih}_{2,2} & w^{ih}_{2,3} & w^{ih}_{2,4} \\
w^{ih}_{3,1} & w^{ih}_{3,2} & w^{ih}_{3,3} & w^{ih}_{3,4} \\
\end{pmatrix}
\end{equation}

\begin{equation}
H = \begin{pmatrix}
h_{1} & h_{2} & h_{3} & h_{4}
\end{pmatrix}
\end{equation}

\begin{equation}
W_{ho} = \begin{pmatrix}
w^{ho}_{1,1} & w^{ho}_{1,2} \\
w^{ho}_{2,1} & w^{ho}_{2,2} \\
w^{ho}_{3,1} & w^{ho}_{3,2} \\
w^{ho}_{4,1} & w^{ho}_{4,2} \\
\end{pmatrix}
\end{equation}

\begin{equation}
O = \begin{pmatrix}
o_{1} & o_{2}
\end{pmatrix}
\end{equation}

\begin{equation}
S = \begin{pmatrix}
s_{1} & s_{2}
\end{pmatrix}
\end{equation}

From those matrices you can propagate the input $I$ to the output $O$ using the following calculations:

\begin{equation}
\begin{split}
H = \sigma (I \cdot W_{ih}) \\
O =  \sigma (H \cdot W_{ho}) \\
\end{split}
\end{equation}

If the network is properly trained, the output $O$ should be very close from the expected $S$ matrix.
If not, this mind we need to train the artificial neural network with the training data-set and back-propagate the error to adjust weights.

We are now going to use propagated results to back-propagate the error of each layers.
$E_o$ and $E_h$ are error of layers $O$ and $H$.
Matrix $gW_{ho}$ and $gW_{ih}$ are the gradient to adjust weights.

\begin{equation}
\begin{split}
E_o = (S - O) \times \sigma'(O) \\
gW_{ho} =  H^T \cdot E_o \\
\end{split}
\end{equation}

\begin{equation}
\begin{split}
E_h = (E_o \cdot W_{ho}) \times \sigma'(H) \\
gW_{ih} = I^T \cdot E_h \\
\end{split}
\end{equation}

\begin{equation}
\begin{split}
W_{ho} = W_{ho} + gW_{ho} \\
W_{ih} = W_{ih} + gW_{ih} \\
\end{split}
\end{equation}

Weights are updated.
Training continue until we are satisfied with the result.

\subsection{Train Neural Network}
I recommend training \emph{Neural Network} on a computer.
Otherwise you may quickly run into memory error on your MicroPython board, even if you use garbage collect.

\begin{lstlisting}[frame=single]
from matrix import Matrix
import neuralnetwork as nn

# Create neural network with an input layer of 3, an hidden layer of 4
# and an output layer of 2 by default the activation function is sigmoid()
# but a ReLU also exist as relu()
ann = nn.DFF((3, 4, 2))
\end{lstlisting}

Now let's create a training set with input matrix and output matrix.

\begin{lstlisting}[frame=single]
training_set = [
    [Matrix([[0, 0, 0]]), Matrix([[1, 0]])],
    [Matrix([[0, 0, 1]]), Matrix([[0, 1]])],
    [Matrix([[0, 1, 1]]), Matrix([[0, 1]])],
    [Matrix([[0, 1, 0]]), Matrix([[1, 0]])],
    [Matrix([[1, 1, 0]]), Matrix([[0, 1]])],
    [Matrix([[1, 1, 1]]), Matrix([[1, 0]])],
    [Matrix([[1, 0, 1]]), Matrix([[0, 1]])],
    [Matrix([[1, 0, 0]]), Matrix([[1, 0]])],
    ]
\end{lstlisting}

We train the network a thousand times with the training set.
The learning rate (\emph{lrate}) is set to one by default

\begin{lstlisting}[frame=single]
print('Learning progress')
for i in range(1000):
    for a, s in training_set:
        ann.train(a, s, lrate=1)
    if i % 10 == 0:
        print('.', end='')
\end{lstlisting}

Check if you are satisfied with the training.

\begin{lstlisting}[frame=single]
def short(a):
    return round(a, 3)


print('=' * 20)
score = True
for a, s in training_set:
    p = ann.predict(a)
    scr = str(p.map(round)) == str(s.map(short))
    print(a.map(short), p.map(short), p.map(round), s.map(short), scr)
    score &= scr
print('Good learning?', score)
\end{lstlisting}

Print out weights.

\begin{lstlisting}[frame=single]
print('=' * 20)
print('Rounded weights')
for i, w in enumerate(ann.weights):
    print('W{}'.format(i), w.map(round))
\end{lstlisting}


\subsection{Predict}

With the trained weights, we can now use our network.

\begin{lstlisting}[frame=single]
from matrix import Matrix
from neuralnetwork import DFF

ann = DFF(
    (3, 4, 2),
    weights=[
        Matrix([[-1, -4, 6, -4], [5, 0, 6, 1], [4, -4, -8, 6]]),
        Matrix([[-10, 10], [5, -5], [7, -7], [6, -6]])
        ]
    )

d = Matrix(((1, 0, 1)))
p = ann.predict(d)
print(p)
\end{lstlisting}
